<?php
namespace Teknisa\MAN\Controllers;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response\Notification;
use Zeedhi\Framework\DataSource;
use Zeedhi\Framework\DataSource\Manager;
use Zeedhi\Framework\DataSource\ParameterBag;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DataSource\FilterCriteria;
use Zeedhi\Framework\DTO\Response\Message;
use Teknisa\MAN\Utilities;
use Zeedhi\Framework\Controller\CrudWithParameterBag;
use Zeedhi\Framework\DTO\Response\Error; 
use Teknisa\MAN\Services\ProdSubsidiadoFilialService;


class ProdutosSubsidiadoFilial extends CrudWithParameterBag { 
    
    const dataSourcePrincipal = 'vnd06000_prodSubsidiadoFilial';
    const dataSourceProduto   = 'vnd06000_prodSubsidiadoFilial_produto'; 
    
    protected $utilService,
              $parameterBagColumns = array('CDFILIAL', 'NRORG');
              
              
    public function __construct ($crudService, $parameterBag, $entityManager, Utilities\Util $utilService, Manager $dataSourceManager, ProdSubsidiadoFilialService $prodSubsService) {
        $this->crudService           = $crudService;
        $this->parameterBag          = $parameterBag;
        $this->entityManager         = $entityManager;
        $this->utilService           = $utilService;
        $this->dataSourceManager     = $dataSourceManager;
        $this->prodSubsidiadoService = $prodSubsService;
    }
    
    public function findPrincipal(DTO\Request\Filter $request, DTO\Response $response){
        $this->dataSourceName      = self::dataSourcePrincipal;
        $this->parameterBagColumns = $this->parameterBagColumns;
        parent::find($request,$response);
    }
    
    public function findProduto(DTO\Request\Filter $request, DTO\Response $response){
        $this->dataSourceName      =  self::dataSourceProduto;
        $this->parameterBagColumns = $this->parameterBagColumns;
        parent::find($request, $response);
    }
    
    
    public function saveProduct(DTO\Request\DataSet $request, DTO\Response $response){ 
        $conditions = $this->utilService->getParamsAsArray($request);
        $this->prodSubsidiadoService->saveProduct($conditions);
    }
    
    public function autoSaveProduct(DTO\Request\Row $request, DTO\Response $response){
        $conditions = $this->utilService->getParamsAsArray($request);
        $this->prodSubsidiadoService->autoSaveProduct($conditions);
    }
    
    
    public function deleteChecked(DTO\Request\Row $request, DTO\Response $response){
        $conditions = $this->utilService->getParamsAsArray($request);
        $this->prodSubsidiadoService->deleteChecked($conditions);
    }
    
    public function deleteProduct(DTO\Request\Row $request, DTO\Response $response){
        $this->dataSourceName = self::dataSourcePrincipal;
        try {
            $request = $this->crudService->buildDataSetIfRow($request, $this->dataSourceName);
            $dataSet = $request->getDataSet();
            $dataSet->setDataSourceName($this->dataSourceName);
            $deletedRows = $this->dataSourceManager->delete($dataSet);
        } catch (\Exception $e) {
            $response->setCriticalError(new DTO\Response\Error($e->getMessage(), $e->getCode(), $e->getTraceAsString()));
        }
    }
}