<?php
namespace Teknisa\MAN\Controllers;

use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DataSource\FilterCriteria;
use Zeedhi\Framework\DataSource\ParameterBag;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DTO\Request;
use Teknisa\MAN\Services;
use Teknisa\MAN\Utilities;



class relatorioMesasAbertasController {
    
    protected $services;
    
    public function __construct(Services\relatorioMesasAbertasServices $services,  Utilities\Util $utilService) {
        $this->services = $services;
        $this->utilService = $utilService;
    }
    
    public function find(DTO\Request\Filter $request, DTO\Response $response){
        
        $conditions = $this->utilService->getParamsAsArray($request);
        
        $return = array();
        $params = array();
        $size = Sizeof($conditions);
        
        
        if (!isset($conditions['CDLOJA'])){
            $conditions['CDLOJA'] = 'T';
        }
        if($conditions['CDLOJA']>1 ){
            
            $lojas = implode("_",$conditions['CDLOJA']);
            $conditions['CDLOJA'] = $lojas;
        }

        $comanda = $this->services->findComanda($conditions);
     
        $response->addDataSet(new DataSet('relatorioMesasAbertas', $comanda));
    }
    
    
}
