<?php
namespace Teknisa\MAN\Services;

use Doctrine\ORM\EntityManager;
use Teknisa\MAN\Utilities;

class ProdutoPorServicoService {

	protected $entityManager;

	public function __construct(\Doctrine\ORM\EntityManager $entityManager)  {
		$this->entityManager = $entityManager;
	}
	
	
	public function deleteProdServCascade($CDSERVFILI, $NRORG, $CDFILIAL, $CDCAIXA) {
        $params = array(
            ':CDSERVFILI'         => $CDSERVFILI,
            ':NRORG'            => $NRORG,
            ':CDFILIAL'         => $CDFILIAL,
            ':CDCAIXA'         => $CDCAIXA
 		);
 		
 		$this->entityManager->getConnection()->executeQuery(self::DELETE_PRODSERVTCON, $params);
 		$this->entityManager->getConnection()->executeQuery(self::DELETE_PRODSERV, $params);
 		return $this->entityManager->getConnection()->executeQuery(self::DELETE_SERV, $params);
    }
    
    public function updateProd($conditions){
    	
		return $this->entityManager->getConnection()->executeQuery(self::UPDATE_PROD, $conditions);
	}
	
	public function updateProdCons($conditions){
    	
		return $this->entityManager->getConnection()->executeQuery(self::UPDATE_PRODCONS, $conditions);
	}

    const UPDATE_PROD = "UPDATE PRODTURCAIXA
			SET
			    QTLIMCONPROD = :QTLIMCONPROD,
			    IDCARGAUTOPR = :IDCARGAUTOPR
			WHERE CDFILIAL = :CDFILIAL
			    AND CDCAIXA = :CDCAIXA
			    AND CDSERVFILI = :CDSERVFILI
			    AND CDPRODUTO = :CDPRODUTO
			    AND NRORG = :NRORG
		";
		
	const UPDATE_PRODCONS = "UPDATE PRODSERVTCON
		    SET
		        QTLIMCONPRSE = :QTLIMCONPRSE,
		        IDCARGAUTOPS = :IDCARGAUTOPS
		    WHERE CDFILIAL = :CDFILIAL
		        AND CDCAIXA = :CDCAIXA
		        AND CDSERVFILI = :CDSERVFILI
		        AND CDPRODUTO = :CDPRODUTO
		        AND CDTIPOCONS = :CDTIPOCONS
		        AND NRORG = :NRORG
		";
    
    const DELETE_SERV = " DELETE FROM SERVTURCAIXA 
	        WHERE NRORG = :NRORG 
	        AND CDFILIAL = :CDFILIAL
	        AND CDSERVFILI = :CDSERVFILI
	        AND CDCAIXA = :CDCAIXA
	    ";
	const DELETE_PRODSERV = " DELETE FROM PRODTURCAIXA 
	        WHERE NRORG = :NRORG 
	        AND CDFILIAL = :CDFILIAL
	        AND CDSERVFILI = :CDSERVFILI
	        AND CDCAIXA = :CDCAIXA
	    ";
	const DELETE_PRODSERVTCON = " DELETE FROM PRODSERVTCON 
	        WHERE NRORG = :NRORG 
	        AND CDFILIAL = :CDFILIAL
	        AND CDSERVFILI = :CDSERVFILI
	        AND CDCAIXA = :CDCAIXA
	    ";
    
    public function verificaCdServ($CDSERVFILI, $NRORG, $CDFILIAL, $CDCAIXA) {
        $params = array(
            ':CDSERVFILI'         => $CDSERVFILI,
            ':NRORG'            => $NRORG,
            ':CDFILIAL'         => $CDFILIAL,
            ':CDCAIXA'         => $CDCAIXA
 		);
		return $this->entityManager->getConnection()->fetchALL(self::VALIDA_CDSERV, $params);
	}

    const VALIDA_CDSERV = "
    SELECT 1 FROM SERVTURCAIXA
		WHERE CDFILIAL = :CDFILIAL
		    AND CDCAIXA = :CDCAIXA
		    AND CDSERVFILI = :CDSERVFILI
		    AND NRORG = :NRORG
	";
    
}
?>