<?php

namespace Teknisa\MAN\Services;

use Doctrine\ORM\EntityManager;
use Teknisa\MAN\Utilities;

class RelNotasNFCeInutilizadasService {
	
	protected $entityManager;

	public function __construct(\Doctrine\ORM\EntityManager $entityManager)  {
		$this->entityManager = $entityManager;
	}
	
	public function getNotas($conditions) {
		$params = array(
			":NRORG"			=> $conditions['NRORG'],
			":CDFILIAL" 		=> array_key_exists('CDFILIAL', $conditions) ? implode('_', $conditions['CDFILIAL']) : NULL,
			":DTINI"			=> $conditions['DTENTRVENDA'][0],
			":DTFIM"			=> $conditions['DTENTRVENDA'][1],
			":NRNOTAFISCALCE"	=> array_key_exists('NRNOTAFISCALCE', $conditions) ? $conditions['NRNOTAFISCALCE'] : 'T',
			":IDSTATUSNFCE" 	=> array_key_exists('IDSTATUSNFCE', $conditions) ? implode('_', $conditions['IDSTATUSNFCE']) : 'T'
			
		);
		return $this->entityManager->getConnection()->fetchAll(self::GET_NOTAS_NFCE_INUTILIZADAS, $params);
	}
	    
	const GET_NOTAS_NFCE_INUTILIZADAS = "
		SELECT INF.CDFILIAL,
		  F.NMFILIAL,
		  (INF.CDFILIAL || ' - ' || F.NMFILIAL) AS LABELFILIAL,
		  INF.CDCAIXA,
		  INF.NRNOTAFISCALCE,
		  INF.DTENTRVENDA,
		  INF.CDSERIENFCE,
		  CASE INF.IDTPAMBNFCE
		    WHEN '1'
		    THEN 'Produção'
		    WHEN '2'
		    THEN 'Homologação'
		  END AS IDTPAMBNFCE,
		  CASE INF.IDSTATUSNFCE
		    WHEN 'P'
		    THEN 'Pendente'
		    WHEN 'R'
		    THEN 'Rejeitada'
		    WHEN 'T'
		    THEN 'Transmitida'
		    WHEN 'A'
		    THEN 'Aceita'
		    WHEN 'D'
		    THEN 'Denegado'
		    WHEN 'C'
		    THEN 'Cancelada'
		  END AS IDSTATUSNFCE,
		  INF.DTHRINUTNFCE
		FROM INUTILIZANFCE INF
		JOIN FILIAL F
		ON (F.CDFILIAL = INF.CDFILIAL 
		AND F.NRORG = INF.NRORG)
		WHERE (INF.NRORG = :NRORG
			AND INF.DTHRINUTNFCE BETWEEN :DTINI AND :DTFIM
			AND ((INSTR(:CDFILIAL, INF.CDFILIAL) <> 0))
			AND (((INSTR(:IDSTATUSNFCE, INF.IDSTATUSNFCE) <> 0)) OR (:IDSTATUSNFCE = 'T'))
			AND ((INF.NRNOTAFISCALCE LIKE :NRNOTAFISCALCE) OR (:NRNOTAFISCALCE = 'T')))
	";	    
}
